;Nyan Cat loop for NGCD - furrtek 2011

    cpu 68000
    supmode on

    INCLUDE "regdefs.asm"

FLAG_DOTASKS         equ 0

                     org RAMSTART

FLAGS:               ds.b 1
VBLC:                ds.w 1
WAVE:                ds.b 1
FRAME:               ds.b 1
XPOS                 ds.w 1
YPOS                 ds.w 1
INERX                ds.b 1
INERY                ds.b 1
LASTRB               ds.w 1
RANDOM32             ds.l 1

;W (X)
RAINBOWS:            ds.w 80

;W W (X, FRAME)
POINTS:              ds.w 2*10

    ;INCLUDE "cdheader.asm"
    INCLUDE "header.asm"
    INCLUDE "vblank.asm"

Start:
    lea     $10F300,sp
    move.b  d0,REG_DIPSW
    move.w  #7,REG_IRQACK
    clr.b   FLAGS                 ; Don't do anything special in VBlank
    move.w  #$2000,sr             ; Immediately activate interrupts

    move.l  #($F2FF/2)-1,d7       ; Clear user RAM
    lea     RAMSTART,a0
.clram:
    clr.w   (a0)+
    dbra    d7,.clram

    move.w  #FIXMAP,VRAM_ADDR
    move.w  #1,VRAM_MOD
    move.l  #32-1,d0              ; Clear fix with tile $00, palette 3 (left border)
.clfixlpbl:
    move.w  #$3000,VRAM_RW
    dbra    d0,.clfixlpbl
    move.l  #(38*32)-1,d0         ; Clear fix with tile $FF (transparent)
.clfixlp:
    move.w  #$00FF,VRAM_RW
    dbra    d0,.clfixlp
    move.l  #32-1,d0              ; Clear fix with tile $00, palette 3 (right border)
.clfixlpbr:
    move.w  #$3000,VRAM_RW
    dbra    d0,.clfixlpbr

    lea     Pal_catstrip,a0       ; Load 3 palettes
    lea     PALETTES,a1
    move.l  #(16*3)-1,d7
.ldpal:
    move.w  (a0)+,(a1)+
    dbra    d7,.ldpal

    move.w  #$8237,BACKDROPCOLOR  ; Dark blue
    
    move.w  #96<<4,XPOS           ; Init cat position (12.4)
    move.w  #80<<4,YPOS
    
    move.l  #12345678,RANDOM32    ; Random seed

    ;Sprite allocation is fixed:
    ;1~21  (20): Points (10 pairs)
    ;22~92 (80): Rainbow slices (individual)
    ;93~100 (7): Cat (block)

;Set all sprite sizes to max
    move.w  #SCB2+1,VRAM_ADDR
    move.l  #(20+80+7)-1,d7
.setz:
    move.w  #$0FFF,VRAM_RW
    dbra    d7,.setz

;Init rainbow sprites
    move.w  #64*(1+20),d0         ; Address in SCB1
    move.l  #80-1,d7
.maprainbows:
    move.w  d0,VRAM_ADDR
    lea     Map_rainbow,a0
    move.w  (a0)+,VRAM_RW
    move.w  #$0100,VRAM_RW        ; Rainbow tiles use palette 1
    move.w  (a0)+,VRAM_RW
    move.w  #$0100,VRAM_RW
    move.w  (a0)+,VRAM_RW
    move.w  #$0100,VRAM_RW
    addi.w  #64,d0                ; Next sprite
    dbra    d7,.maprainbows

;Init rainbows Y position
    move.w  #SCB3+(1+20),VRAM_ADDR
    move.l  #80-1,d7
.setyrainbows:                    ; Set all rainbow slices out of screen (Y=256)
    move.w  #((496-256)<<7)+3,VRAM_RW
    dbra    d7,.setyrainbows

;Init cat's sprite block
    move.w  #SCB3+(1+20+80),VRAM_ADDR
    clr.l   d1
    move.w  YPOS,d1
    lsr.w   #4,d1
    neg.w   d1
    addi.w  #496,d1
    lsl.w   #7,d1
    ori.b   #4,d1                 ; 4 tiles height
    move.l  #7-1,d7
.setcat:                          ; Make sprite block
    move.w  d1,VRAM_RW
    ori.w   #$40,d1               ; Sticky bit for the other sprites
    dbra    d7,.setcat

;Init point sprites
    move.w  #64+1,d0              ; SCB1, first sprite, attribute word
    move.l  #10-1,d7
    move.w  #2,VRAM_MOD           ; Skip tile number words
.setpoints:
    move.w  d0,VRAM_ADDR
    move.w  #$0200,VRAM_RW        ; Palette 2 for 2 tiles in 2 sprites
    move.w  #$0200,VRAM_RW
    addi.w  #64,d0
    move.w  d0,VRAM_ADDR
    move.w  #$0200,VRAM_RW
    move.w  #$0200,VRAM_RW
    addi.w  #64,d0
    dbra    d7,.setpoints

;Init points array and Y positions
    move.w  #SCB3+1,VRAM_ADDR
    move.w  #1,VRAM_MOD
    move.l  #10-1,d7
    lea     POINTS,a0
.setpointspos:
    jsr     GALOISPRN
    move.l  RANDOM32,d0
    andi.w  #$1FF,d0              ; Limit initial X to $1FF
    move.w  d0,(a0)+              ; Set in array
    swap    d0
    andi.w  #$FF,d0               ; Limit initial Y to $FF
    neg.w   d0
    addi.w  #496,d0
    lsl.w   #7,d0
    ori.w   #2,d0                 ; 2 tiles height
    move.w  d0,VRAM_RW            ; Set directy to VRAM (never changes during scroll)
    ori.w   #$40,d0               ; Sticky bit for second sprite
    move.w  d0,VRAM_RW
    move.l  RANDOM32,d0
    andi.w  #$F,d0                ; Limit initial frame to $F (will be /2)
    move.w  d0,(a0)+              ; Set in array
    dbra    d7,.setpointspos

    move.b  #$80,REG_SOUND        ; Start music

    bset.b  #FLAG_DOTASKS,FLAGS   ; Let animation run

Loop:
   bra     Loop


GaloisPRN:
    movem.l d0-d2,-(a7)
    move.l  #$AF-$100,d1
    move.l  #18,d2
    move.l  RANDOM32,d0
.ninc0:
    add.l   d0,d0
    bcc     .ninc1
    eor.b   d1,d0
.ninc1:
    dbra    d2,.ninc0
    move.l  d0,RANDOM32
    movem.l (a7)+,d0-d2
    rts

   INCLUDE "nyan_palettes.inc"
   INCLUDE "nyan_tiledefs.inc"
   
Cosinus:                          ; 32 values, $8 to $0
  dc.b $8,$7,$7,$7,$6,$6,$5,$4,$4,$3,$2,$1,$1,$0,$0,$0
  dc.b $0,$0,$0,$0,$1,$1,$2,$3,$3,$4,$5,$6,$6,$7,$7,$7
