VBlank:
    btst    #7,BIOS_SYSSTAT
    bne     .gamemode
    jmp     BIOSF_BOOTSCR
.gamemode:
    movem.l d0-d7/a0-a6,-(a7)
    move.b  d0,REG_DIPSW          ; Watchdog
    btst.b  #FLAG_DOTASKS,FLAGS
    beq     .nothing

    addq.w  #1,VBLC
    addq.b  #1,WAVE

    cmp.w   #1605,VBLC            ; Loop music every 1605 frames
    bne     .nomusicloop
    clr.w   VBLC
    move.b  #$80,REG_SOUND
.nomusicloop:

    jsr     GALOISPRN             ; Make a new PRN
    jsr     BIOSF_VBL             ; Get inputs

    move.b  BIOS_P1CURRENT,d0
    btst    #CNT_UP,d0
    beq     .noup
    cmp.b   #-32,INERY            ; Y inertia lower limit
    ble     .noup
    subq.b  #4,INERY
.noup:
    btst    #CNT_DN,d0
    beq     .nodown
    cmp.b   #32,INERY             ; Y inertia upper limit
    bge     .nodown
    addq.b  #4,INERY
.nodown:
    btst    #CNT_LE,d0
    beq     .noleft
    cmp.b   #-24,INERX            ; X inertia lower limit
    ble     .noleft
    subq.b  #3,INERX
.noleft:
    btst    #CNT_RI,d0
    beq     .noright
    cmp.b   #24,INERX             ; X inertia upper limit
    bge     .noright
    addq.b  #3,INERX
.noright:

    clr.w   d0
    move.b  INERX,d0              ; Update cat's X position with inertia
    ext.w   d0
    add.w   d0,XPOS

    clr.w   d0
    move.b  INERY,d0              ; Update cat's Y position with inertia
    ext.w   d0
    add.w   d0,YPOS

    cmp.w   #130<<4,XPOS          ; Cat position boundaries
    blo     .xnbl
    move.w  #130<<4,XPOS
.xnbl:
    cmp.w   #8<<4,XPOS
    bhi     .xnbh
    move.w  #8<<4,XPOS
.xnbh:
    cmp.w   #144<<4,YPOS
    blo     .ynbl
    move.w  #144<<4,YPOS
.ynbl:
    cmp.w   #8<<4,YPOS
    bhi     .ynbh
    move.w  #8<<4,YPOS
.ynbh:

    tst.b   INERX                 ; Decrease X momentum
    beq     .stoppedx
    blt     .forwx
    subq.b  #1,INERX
    bra     .stoppedx
.forwx:
    addq.b  #1,INERX
.stoppedx:
    tst.b   INERY                 ; Decrease Y momentum
    beq     .stoppedy
    blt     .forwy
    subq.b  #1,INERY
    bra     .stoppedy
.forwy:
    addq.b  #1,INERY
.stoppedy:

;Update rainbows X position
    move.l  #80-1,d7
    lea     RAINBOWS,a0
    move.w  #SCB4+(1+20)+80-1,VRAM_ADDR
    move.w  #-1,VRAM_MOD          ; Write sprites backwards (last to first)
.updrainbows:
    move.w  (a0),d0
    ble.w   .ne
    subq.w  #2,(a0)               ; Make slice go left until it reaches the screen's border
    bra     .ok
.ne:
    clr.w   (a0)
.ok:
    move.w  (a0)+,d1
    lsl.w   #7,d1
    move.w  d1,VRAM_RW            ; Set updated X position
    dbra    d7,.updrainbows

    tst.w   LASTRB
    ble     .nod
    subq.w  #2,LASTRB             ; Decrease last generated rainbow slice position
.nod:

;Generate rainbows
    move.w  XPOS,d0
    lsr.w   #4,d0                 ; 12.4
    addi.w  #$1D,d0               ; Rainbows start relative to cat
    sub.w   LASTRB,d0
    cmp.w   #2,d0                 ; Check if the last generated rainbow is more than 2 pixels left from the cat's position
    blo     .norainbow
    lea     RAINBOWS-2,a0         ; Compensate for adda 2
    move.l  #80,d7
.findrainbow:
    subq.b  #1,d7
    adda.l  #2,a0
    cmpa.l  #RAINBOWS+(2*80),a0
    beq     .norainbow            ; Didn't find a free slice
    tst.w   (a0)                  ; Find a rainbow slice whose X position is 0 (free)
    bne     .findrainbow
    move.w  XPOS,d0
    lsr.w   #4,d0                 ; 12.4
    addi.w  #$1D,d0
    move.w  d0,(a0)+              ; Set rainbow slice's X position according to cat's position
    move.w  d0,LASTRB             ; And last generated rainbow position also
    move.w  YPOS,d0
    lsr.w   #4,d0                 ; 12.4
    addi.w  #$4,d0                ; Top offset
    lea     Cosinus,a1
    clr.l   d1
    move.b  WAVE,d1
    andi.b  #$1F,d1               ; Limit table index to $1F
    move.b  0(a1,d1),d1           ; Make Y position from cat's position and cos wave
    add.w   d1,d0
    move.l  #SCB3+(1+20),d1       ; Set rainbow slice's Y position directly to VRAM (never changes)
    add.w   d7,d1
    move.w  d1,VRAM_ADDR
    neg.w   d0
    addi.w  #496,d0
    lsl.w   #7,d0
    ori.w   #3,d0                 ; 3 tiles height
    move.w  d0,VRAM_RW
.norainbow:

;Update cat's frame
    addq.b  #1,FRAME
    cmpi.b  #6<<1,FRAME           ; Cycle cat's frames (0~5)
    bne     .nowrapc
    clr.b   FRAME
.nowrapc:
    clr.l   d2
    move.b  FRAME,d2
    lsr.b   #1,d2                 ; /2 to slow down (frame updated each 2 frames)
    mulu    #28,d2                ; Number of tiles per cat frame
    move.w  #64*(1+20+80),d0      ; Address in SCB1
    move.w  #1,VRAM_MOD
    lea     Map_catstrip,a0
    move.l  #7-1,d6
.mapx:
    move.w  d0,VRAM_ADDR
    move.l  #4-1,d7
.mapy:
    move.w  (a0)+,d1              ; Get tile number from map
    add.w   d2,d1
    move.w  d1,VRAM_RW
    nop
    nop
    move.w  #0,VRAM_RW            ; Palette 0
    dbra    d7,.mapy
    addi.w  #64,d0                ; Next sprite
    dbra    d6,.mapx

;Update cat's Y position
    move.w  #SCB3+(1+20+80),VRAM_ADDR
    move.w  YPOS,d1
    lsr.w   #4,d1                 ; 12.4
    neg.w   d1
    addi.w  #496,d1
    lsl.w   #7,d1
    ori.b   #4,d1                 ; 4 tiles height
    move.w  d1,VRAM_RW

;Update cat's X position
    move.w  #SCB4+(1+20+80),VRAM_ADDR
    move.w  XPOS,d1
    lsr.w   #4,d1                 ; 12.4
    lsl.w   #7,d1
    move.w  d1,VRAM_RW
    

;Update points frames
    move.w  #64,d0                ; SCB1, sprite 1
    move.l  #10-1,d7
    lea     POINTS+2,a1           ; Point to frame numbers in array
    move.w  #2,VRAM_MOD           ; Skip attribute words
.mappoints:
    move.w  d0,VRAM_ADDR
    clr.l   d2
    addq.w  #1,(a1)               ; Cycle point's frame (0~5)
    cmp.w   #6<<2,(a1)
    bne     .nowrapp
    clr.w   (a1)
.nowrapp:
    move.w  (a1),d2               ; Get frame number
    andi.w  #$FFFC,d2             ; /4 to slow down (frame updated each 4 frames) and *4 tiles per point frame
    move.w  Map_point,d1
    add.w   d2,d1
    move.w  d1,VRAM_RW
    addq.w  #1,d1
    move.w  d1,VRAM_RW
    addi.w  #64,d0                ; Second sprite
    move.w  d0,VRAM_ADDR
    addq.w  #1,d1
    move.w  d1,VRAM_RW
    addq.w  #1,d1
    move.w  d1,VRAM_RW
    addi.w  #64,d0                ; Next sprite
    adda.l  #4,a1
    dbra    d7,.mappoints


;Update points X position
    move.w  #1,VRAM_MOD
    move.l  #10-1,d7
    lea     POINTS,a0
.setxp:
    subq.w  #1,(a0)               ; Scroll point to the left
    tst.w   (a0)
    bne     .nopointreset
    move.l  RANDOM32,d0           ; Point reached left border
    andi.w  #$FF,d0
    addi.w  #320,d0
    move.w  d0,(a0)               ; Set X in array, in between 320 and 320+$FF
    move.l  RANDOM32,d0
    swap    d0
    andi.w  #$FF,d0               ; Set Y directly in VRAM once, in between 0 and $FF
    move.w  #SCB3+1,d1
    add.w   d7,d1                 ; Driving sprite each two sprites
    add.w   d7,d1
    move.w  d1,VRAM_ADDR
    neg.w   d0
    addi.w  #496,d0
    lsl.w   #7,d0
    ori.w   #2,d0                 ; 2 tiles height
    move.w  d0,VRAM_RW
.nopointreset:
    move.w  #SCB4+1,d1            ; Set X position in VRAM
    add.w   d7,d1                 ; Driving sprite each two sprites
    add.w   d7,d1
    move.w  d1,VRAM_ADDR
    move.w  (a0),d0
    subi.w  #32,d0                ; Make left limit go down to -32
    lsl.w   #7,d0
    move.w  d0,VRAM_RW
    adda.l  #4,a0
    dbra    d7,.setxp


.nothing:
    movem.l (a7)+,d0-d7/a0-a6
    move.w  #4,REG_IRQACK
    rte
